<html>
<head>
<title>Ogre::RTShader::SubRenderStateAccessor Class Reference - OGRE Documentation</title> <meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1"> 
<link type="text/css" rel="stylesheet" href="doxygen.css">
<link type="text/css" rel="stylesheet" href="tabs.css">
</head>

<body>
<!-- Generated by Doxygen 1.7.6.1 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.html"><span>Main&#160;Page</span></a></li>
      <li><a href="pages.html"><span>Related&#160;Pages</span></a></li>
      <li><a href="modules.html"><span>Modules</span></a></li>
      <li><a href="namespaces.html"><span>Namespaces</span></a></li>
      <li class="current"><a href="annotated.html"><span>Classes</span></a></li>
      <li><a href="files.html"><span>Files</span></a></li>
      <li><a href="dirs.html"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="annotated.html"><span>Class&#160;List</span></a></li>
      <li><a href="classes.html"><span>Class&#160;Index</span></a></li>
      <li><a href="inherits.html"><span>Class&#160;Hierarchy</span></a></li>
      <li><a href="functions.html"><span>Class&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="namespaceOgre.html">Ogre</a>      </li>
      <li class="navelem"><a class="el" href="namespaceOgre_1_1RTShader.html">RTShader</a>      </li>
      <li class="navelem"><a class="el" href="classOgre_1_1RTShader_1_1SubRenderStateAccessor.html">SubRenderStateAccessor</a>      </li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="summary">
<a href="#pub-methods">Public Member Functions</a> &#124;
<a href="#pro-methods">Protected Member Functions</a> &#124;
<a href="#pro-attribs">Protected Attributes</a> &#124;
<a href="#friends">Friends</a>  </div>
  <div class="headertitle">
<div class="title">Ogre::RTShader::SubRenderStateAccessor Class Reference<div class="ingroups"><a class="el" href="group__RTShader.html">RTShader</a></div></div>  </div>
</div><!--header-->
<div class="contents">
<!-- doxytag: class="Ogre::RTShader::SubRenderStateAccessor" -->
<p>This class uses as accessor from a template <a class="el" href="classOgre_1_1RTShader_1_1SubRenderState.html" title="This class is the base interface of sub part from a shader based rendering pipeline.">SubRenderState</a> to all of its instances that created based on it.  
 <a href="classOgre_1_1RTShader_1_1SubRenderStateAccessor.html#details">More...</a></p>

<p><code>#include &lt;<a class="el" href="OgreShaderSubRenderState_8h_source.html">OgreShaderSubRenderState.h</a>&gt;</code></p>

<p><a href="classOgre_1_1RTShader_1_1SubRenderStateAccessor-members.html">List of all members.</a></p>
<table class="memberdecls">
<tr><td colspan="2"><h2><a name="pub-methods"></a>
Public Member Functions</h2></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1RTShader_1_1SubRenderStateAccessor.html#a471587382fbc688fd2fb9d5de74fe0b7">addSubRenderStateInstance</a> (<a class="el" href="classOgre_1_1RTShader_1_1SubRenderState.html">SubRenderState</a> *subRenderState) const </td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Add <a class="el" href="classOgre_1_1RTShader_1_1SubRenderState.html" title="This class is the base interface of sub part from a shader based rendering pipeline.">SubRenderState</a> instance to this accessor.  <a href="#a471587382fbc688fd2fb9d5de74fe0b7"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1RTShader_1_1SubRenderStateAccessor.html#afd2b1664c77cbc1afa2c6f4fcefdc7dd">removeSubRenderStateInstance</a> (<a class="el" href="classOgre_1_1RTShader_1_1SubRenderState.html">SubRenderState</a> *subRenderState) const </td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Remove <a class="el" href="classOgre_1_1RTShader_1_1SubRenderState.html" title="This class is the base interface of sub part from a shader based rendering pipeline.">SubRenderState</a> instance to this accessor.  <a href="#afd2b1664c77cbc1afa2c6f4fcefdc7dd"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top"><a class="el" href="group__RTShader.html#ga80ca8b84f487bd915b32ae12159a0131">SubRenderStateSet</a> &amp;&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1RTShader_1_1SubRenderStateAccessor.html#a5f37c0a472ebbcb4b8490d69c55691e7">getSubRenderStateInstanceSet</a> ()</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Return a set of all instances of the template <a class="el" href="classOgre_1_1RTShader_1_1SubRenderState.html" title="This class is the base interface of sub part from a shader based rendering pipeline.">SubRenderState</a>.  <a href="#a5f37c0a472ebbcb4b8490d69c55691e7"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">const <a class="el" href="group__RTShader.html#ga80ca8b84f487bd915b32ae12159a0131">SubRenderStateSet</a> &amp;&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1RTShader_1_1SubRenderStateAccessor.html#ae2af5197a8340757364b51526a59c433">getSubRenderStateInstanceSet</a> () const </td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Return a set of all instances of the template <a class="el" href="classOgre_1_1RTShader_1_1SubRenderState.html" title="This class is the base interface of sub part from a shader based rendering pipeline.">SubRenderState</a>.  <a href="#ae2af5197a8340757364b51526a59c433"></a><br/></td></tr>
<tr><td colspan="2"><h2><a name="pro-methods"></a>
Protected Member Functions</h2></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1RTShader_1_1SubRenderStateAccessor.html#a2e78aff406d5eebe681f7422672e57de">SubRenderStateAccessor</a> (const <a class="el" href="classOgre_1_1RTShader_1_1SubRenderState.html">SubRenderState</a> *templateSubRenderState)</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Construct <a class="el" href="classOgre_1_1RTShader_1_1SubRenderState.html" title="This class is the base interface of sub part from a shader based rendering pipeline.">SubRenderState</a> accessor based on the given template <a class="el" href="classOgre_1_1RTShader_1_1SubRenderState.html" title="This class is the base interface of sub part from a shader based rendering pipeline.">SubRenderState</a>.  <a href="#a2e78aff406d5eebe681f7422672e57de"></a><br/></td></tr>
<tr><td colspan="2"><h2><a name="pro-attribs"></a>
Protected Attributes</h2></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">const <a class="el" href="classOgre_1_1RTShader_1_1SubRenderState.html">SubRenderState</a> *&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1RTShader_1_1SubRenderStateAccessor.html#a30c0e37a80640c85a4e9b6af4f691593">mTemplateSubRenderState</a></td></tr>
<tr><td class="memItemLeft" align="right" valign="top"><a class="el" href="group__RTShader.html#ga80ca8b84f487bd915b32ae12159a0131">SubRenderStateSet</a>&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1RTShader_1_1SubRenderStateAccessor.html#a84a3bc00bbde5505d5112f9930ac9352">mSubRenderStateInstancesSet</a></td></tr>
<tr><td colspan="2"><h2><a name="friends"></a>
Friends</h2></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">class&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1RTShader_1_1SubRenderStateAccessor.html#a00dfbcca6566234803f04f46c66cb1e2">SubRenderState</a></td></tr>
</table>
<hr/><a name="details" id="details"></a><h2>Detailed Description</h2>
<div class="textblock"><p>This class uses as accessor from a template <a class="el" href="classOgre_1_1RTShader_1_1SubRenderState.html" title="This class is the base interface of sub part from a shader based rendering pipeline.">SubRenderState</a> to all of its instances that created based on it. </p>
<p>Since <a class="el" href="classOgre_1_1RTShader_1_1SubRenderState.html" title="This class is the base interface of sub part from a shader based rendering pipeline.">SubRenderState</a> that added as templates to a <a class="el" href="classOgre_1_1RTShader_1_1RenderState.html" title="This is a container class for sub render state class.">RenderState</a> are not directly used by the system this class enable accessing the used instances. A common usage will be add a <a class="el" href="classOgre_1_1RTShader_1_1SubRenderState.html" title="This class is the base interface of sub part from a shader based rendering pipeline.">SubRenderState</a> to certain pass, obtain accessor and then call a method on the instanced <a class="el" href="classOgre_1_1RTShader_1_1SubRenderState.html" title="This class is the base interface of sub part from a shader based rendering pipeline.">SubRenderState</a> that will trigger some GPU uniform parameter updates. </p>

<p>Definition at line <a class="el" href="OgreShaderSubRenderState_8h_source.html#l00175">175</a> of file <a class="el" href="OgreShaderSubRenderState_8h_source.html">OgreShaderSubRenderState.h</a>.</p>
</div><hr/><h2>Constructor &amp; Destructor Documentation</h2>
<a class="anchor" id="a2e78aff406d5eebe681f7422672e57de"></a><!-- doxytag: member="Ogre::RTShader::SubRenderStateAccessor::SubRenderStateAccessor" ref="a2e78aff406d5eebe681f7422672e57de" args="(const SubRenderState *templateSubRenderState)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="classOgre_1_1RTShader_1_1SubRenderStateAccessor.html#a2e78aff406d5eebe681f7422672e57de">Ogre::RTShader::SubRenderStateAccessor::SubRenderStateAccessor</a> </td>
          <td>(</td>
          <td class="paramtype">const <a class="el" href="classOgre_1_1RTShader_1_1SubRenderState.html">SubRenderState</a> *&#160;</td>
          <td class="paramname"><em>templateSubRenderState</em></td><td>)</td>
          <td><code> [protected]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Construct <a class="el" href="classOgre_1_1RTShader_1_1SubRenderState.html" title="This class is the base interface of sub part from a shader based rendering pipeline.">SubRenderState</a> accessor based on the given template <a class="el" href="classOgre_1_1RTShader_1_1SubRenderState.html" title="This class is the base interface of sub part from a shader based rendering pipeline.">SubRenderState</a>. </p>

<p>Definition at line <a class="el" href="OgreShaderSubRenderState_8h_source.html#l00206">206</a> of file <a class="el" href="OgreShaderSubRenderState_8h_source.html">OgreShaderSubRenderState.h</a>.</p>

</div>
</div>
<hr/><h2>Member Function Documentation</h2>
<a class="anchor" id="a471587382fbc688fd2fb9d5de74fe0b7"></a><!-- doxytag: member="Ogre::RTShader::SubRenderStateAccessor::addSubRenderStateInstance" ref="a471587382fbc688fd2fb9d5de74fe0b7" args="(SubRenderState *subRenderState) const " -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void <a class="el" href="classOgre_1_1RTShader_1_1SubRenderStateAccessor.html#a471587382fbc688fd2fb9d5de74fe0b7">Ogre::RTShader::SubRenderStateAccessor::addSubRenderStateInstance</a> </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="classOgre_1_1RTShader_1_1SubRenderState.html">SubRenderState</a> *&#160;</td>
          <td class="paramname"><em>subRenderState</em></td><td>)</td>
          <td> const</td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Add <a class="el" href="classOgre_1_1RTShader_1_1SubRenderState.html" title="This class is the base interface of sub part from a shader based rendering pipeline.">SubRenderState</a> instance to this accessor. </p>

<p>Definition at line <a class="el" href="OgreShaderSubRenderState_8h_source.html#l00180">180</a> of file <a class="el" href="OgreShaderSubRenderState_8h_source.html">OgreShaderSubRenderState.h</a>.</p>

</div>
</div>
<a class="anchor" id="a5f37c0a472ebbcb4b8490d69c55691e7"></a><!-- doxytag: member="Ogre::RTShader::SubRenderStateAccessor::getSubRenderStateInstanceSet" ref="a5f37c0a472ebbcb4b8490d69c55691e7" args="()" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="group__RTShader.html#ga80ca8b84f487bd915b32ae12159a0131">SubRenderStateSet</a>&amp; <a class="el" href="classOgre_1_1RTShader_1_1SubRenderStateAccessor.html#a5f37c0a472ebbcb4b8490d69c55691e7">Ogre::RTShader::SubRenderStateAccessor::getSubRenderStateInstanceSet</a> </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Return a set of all instances of the template <a class="el" href="classOgre_1_1RTShader_1_1SubRenderState.html" title="This class is the base interface of sub part from a shader based rendering pipeline.">SubRenderState</a>. </p>

<p>Definition at line <a class="el" href="OgreShaderSubRenderState_8h_source.html#l00198">198</a> of file <a class="el" href="OgreShaderSubRenderState_8h_source.html">OgreShaderSubRenderState.h</a>.</p>

</div>
</div>
<a class="anchor" id="ae2af5197a8340757364b51526a59c433"></a><!-- doxytag: member="Ogre::RTShader::SubRenderStateAccessor::getSubRenderStateInstanceSet" ref="ae2af5197a8340757364b51526a59c433" args="() const " -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">const <a class="el" href="group__RTShader.html#ga80ca8b84f487bd915b32ae12159a0131">SubRenderStateSet</a>&amp; <a class="el" href="classOgre_1_1RTShader_1_1SubRenderStateAccessor.html#a5f37c0a472ebbcb4b8490d69c55691e7">Ogre::RTShader::SubRenderStateAccessor::getSubRenderStateInstanceSet</a> </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td> const</td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Return a set of all instances of the template <a class="el" href="classOgre_1_1RTShader_1_1SubRenderState.html" title="This class is the base interface of sub part from a shader based rendering pipeline.">SubRenderState</a>. </p>
<p>(const version). </p>

<p>Definition at line <a class="el" href="OgreShaderSubRenderState_8h_source.html#l00201">201</a> of file <a class="el" href="OgreShaderSubRenderState_8h_source.html">OgreShaderSubRenderState.h</a>.</p>

</div>
</div>
<a class="anchor" id="afd2b1664c77cbc1afa2c6f4fcefdc7dd"></a><!-- doxytag: member="Ogre::RTShader::SubRenderStateAccessor::removeSubRenderStateInstance" ref="afd2b1664c77cbc1afa2c6f4fcefdc7dd" args="(SubRenderState *subRenderState) const " -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void <a class="el" href="classOgre_1_1RTShader_1_1SubRenderStateAccessor.html#afd2b1664c77cbc1afa2c6f4fcefdc7dd">Ogre::RTShader::SubRenderStateAccessor::removeSubRenderStateInstance</a> </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="classOgre_1_1RTShader_1_1SubRenderState.html">SubRenderState</a> *&#160;</td>
          <td class="paramname"><em>subRenderState</em></td><td>)</td>
          <td> const</td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Remove <a class="el" href="classOgre_1_1RTShader_1_1SubRenderState.html" title="This class is the base interface of sub part from a shader based rendering pipeline.">SubRenderState</a> instance to this accessor. </p>

<p>Definition at line <a class="el" href="OgreShaderSubRenderState_8h_source.html#l00187">187</a> of file <a class="el" href="OgreShaderSubRenderState_8h_source.html">OgreShaderSubRenderState.h</a>.</p>

</div>
</div>
<hr/><h2>Friends And Related Function Documentation</h2>
<a class="anchor" id="a00dfbcca6566234803f04f46c66cb1e2"></a><!-- doxytag: member="Ogre::RTShader::SubRenderStateAccessor::SubRenderState" ref="a00dfbcca6566234803f04f46c66cb1e2" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">friend class <a class="el" href="classOgre_1_1RTShader_1_1SubRenderState.html">SubRenderState</a><code> [friend]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Definition at line <a class="el" href="OgreShaderSubRenderState_8h_source.html#l00214">214</a> of file <a class="el" href="OgreShaderSubRenderState_8h_source.html">OgreShaderSubRenderState.h</a>.</p>

</div>
</div>
<hr/><h2>Member Data Documentation</h2>
<a class="anchor" id="a84a3bc00bbde5505d5112f9930ac9352"></a><!-- doxytag: member="Ogre::RTShader::SubRenderStateAccessor::mSubRenderStateInstancesSet" ref="a84a3bc00bbde5505d5112f9930ac9352" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="group__RTShader.html#ga80ca8b84f487bd915b32ae12159a0131">SubRenderStateSet</a> <a class="el" href="classOgre_1_1RTShader_1_1SubRenderStateAccessor.html#a84a3bc00bbde5505d5112f9930ac9352">Ogre::RTShader::SubRenderStateAccessor::mSubRenderStateInstancesSet</a><code> [mutable, protected]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Definition at line <a class="el" href="OgreShaderSubRenderState_8h_source.html#l00211">211</a> of file <a class="el" href="OgreShaderSubRenderState_8h_source.html">OgreShaderSubRenderState.h</a>.</p>

</div>
</div>
<a class="anchor" id="a30c0e37a80640c85a4e9b6af4f691593"></a><!-- doxytag: member="Ogre::RTShader::SubRenderStateAccessor::mTemplateSubRenderState" ref="a30c0e37a80640c85a4e9b6af4f691593" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">const <a class="el" href="classOgre_1_1RTShader_1_1SubRenderState.html">SubRenderState</a>* <a class="el" href="classOgre_1_1RTShader_1_1SubRenderStateAccessor.html#a30c0e37a80640c85a4e9b6af4f691593">Ogre::RTShader::SubRenderStateAccessor::mTemplateSubRenderState</a><code> [protected]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Definition at line <a class="el" href="OgreShaderSubRenderState_8h_source.html#l00210">210</a> of file <a class="el" href="OgreShaderSubRenderState_8h_source.html">OgreShaderSubRenderState.h</a>.</p>

</div>
</div>
<hr/>The documentation for this class was generated from the following file:<ul>
<li><a class="el" href="OgreShaderSubRenderState_8h_source.html">OgreShaderSubRenderState.h</a></li>
</ul>
</div><!-- contents -->
<hr>
<p>
Copyright &copy; 2012 Torus Knot Software Ltd<br />
<!--Creative Commons License--><a rel="license" href="http://creativecommons.org/licenses/by-sa/3.0/"><img alt="Creative Commons License" style="border-width:0" src="http://i.creativecommons.org/l/by-sa/3.0/88x31.png" /></a><br />This work is licensed under a <a rel="license" href="http://creativecommons.org/licenses/by-sa/3.0/">Creative Commons Attribution-ShareAlike 3.0 Unported License</a>.<br/>
		<!--/Creative Commons License--><!-- <rdf:RDF xmlns="http://web.resource.org/cc/" xmlns:dc="http://purl.org/dc/elements/1.1/" xmlns:rdf="http://www.w3.org/1999/02/22-rdf-syntax-ns#">
		<Work rdf:about="">
			<license rdf:resource="http://creativecommons.org/licenses/by-sa/2.5/" />
	<dc:type rdf:resource="http://purl.org/dc/dcmitype/Text" />
		</Work>
		<License rdf:about="http://creativecommons.org/licenses/by-sa/2.5/"><permits rdf:resource="http://web.resource.org/cc/Reproduction"/><permits rdf:resource="http://web.resource.org/cc/Distribution"/><requires rdf:resource="http://web.resource.org/cc/Notice"/><requires rdf:resource="http://web.resource.org/cc/Attribution"/><permits rdf:resource="http://web.resource.org/cc/DerivativeWorks"/><requires rdf:resource="http://web.resource.org/cc/ShareAlike"/></License></rdf:RDF> -->

Last modified Fri May 25 2012 21:49:34
</p>
</body>
</html>
